listan(0,[]):- !.
listan(N,L):- N1 is N-1, listan(N1,L1),append(L1,[N],L).

listanp(0,[]):- !.
listanp(N,[N|L1]):- N1 is N-1, listanp(N1,L1).


% Iterative generation of a list [1..N]

gen(N,W):- gen_iter(N,N,[N],W).
gen_iter(_,1,W,W):-!.
gen_iter(N,I,L,W):- I1 is I-1,gen_iter(N,I1,[I1|L],W).

% Recurrent sum of list

sumlist([],0) :- !.
sumlist([H|T],SumList) :- sumlist(T,SumListT), SumList is H + SumListT.
% sumlist([H1,H2|T],SumList) :- sumlist(T,SumListT), SumList is H1 + H2 + SumListT.

% test; pada przy 3 000 000
test(N,S) :- gen(N,W), sumlist(W,S).

%%% Suma iteracyjna

sumiter(L,S) :- iter(L,0,S).

iter([],W,W) :- !.
iter([H|T],A,W) :- AH is A + H, iter(T,AH,W).


% test dziala nawet do  10 000 000 

testiter(N,S) :- gen(N,W), sumiter(W,S).
